// c2011 Adobe Systems, Inc. All rights reserved.
// Produced and Directed by Dr. Brown ( a.k.a Russell Preston Brown )
// Written by Tom Ruark because I wrote listener! I get credit for all listener code.

/*
@@@BUILDINFO@@@ Dr Browns Edit Layer in ACR.jsx 1.0.11
*/

// enable double clicking from the Macintosh Finder or the Windows Explorer
#target photoshop

// Show this message just once. 
// If I have preferences then I must of done this already.
var message = "Special Instructions\r";
message += "Make sure that you have set your Camera Raw Preferences to the following setting:\r";
message += "(Automatically open all supported TIFFs)\r";
message += "To access this preference setting, go to your Main Menu and select: Photoshop/Preferences/Camera Raw\r";
message += " \rAlso, your default resolution for TIFF images in ACR must be set to 240ppi. If you see your layers change in size, then you know that your resolution is not set correctly.\r";
message += "";

var optionsID = "5714ecb5-8b21-4327-bf64-135d24ea7131";
var showMessage = true;
try {
    var desc = app.getCustomOptions(optionsID);
    showMessage = false;
}
catch(e) {
    showMessage = true;
}

if (showMessage) {
    alert(message);
    var desc = new ActionDescriptor();
    desc.putInteger(charIDToTypeID('ver '), 1);
    app.putCustomOptions(optionsID, desc);
}


var tempName = "Raw Smart Temp";
var tempFile = new File( Folder.temp.toString() + "/" + tempName + ".tif" );

// save some state so we can restore
// we pop the ACR dialog so users can cancel out and we are in a bad state
var historyDocument = app.activeDocument;
var historyState = app.activeDocument.activeHistoryState;

try {
	
// =======================================================
var idImgS = charIDToTypeID( "ImgS" );
    var desc66 = new ActionDescriptor();
    var idRslt = charIDToTypeID( "Rslt" );
    var idRsl = charIDToTypeID( "#Rsl" );
    desc66.putUnitDouble( idRslt, idRsl, 240.000000 );
executeAction( idImgS, desc66, DialogModes.NO );


var layerMask = HasLayerMask();

var layerTransparency = HasLayerTransparency();

if (layerTransparency) {
   
    // =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc295 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref200 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref200.putProperty( idChnl, idfsel );
    desc295.putReference( idnull, ref200 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idAl = charIDToTypeID( "Al  " );
    desc295.putEnumerated( idT, idOrdn, idAl );
executeAction( idsetd, desc295, DialogModes.NO );

// =======================================================
var idCpyM = charIDToTypeID( "CpyM" );
executeAction( idCpyM, undefined, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc296 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref201 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref201.putProperty( idChnl, idfsel );
    desc296.putReference( idnull, ref201 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idNone = charIDToTypeID( "None" );
    desc296.putEnumerated( idT, idOrdn, idNone );
executeAction( idsetd, desc296, DialogModes.NO );

// =======================================================
var idMk = charIDToTypeID( "Mk  " );
    var desc297 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
        var desc298 = new ActionDescriptor();
        var idNm = charIDToTypeID( "Nm  " );
        desc298.putString( idNm, tempName );
        var idpreset = stringIDToTypeID( "preset" );
        desc298.putString( idpreset, "Clipboard" );
    var idDcmn = charIDToTypeID( "Dcmn" );
    desc297.putObject( idNw, idDcmn, desc298 );
executeAction( idMk, desc297, DialogModes.NO );

// =======================================================
var idpast = charIDToTypeID( "past" );
    var desc299 = new ActionDescriptor();
    var idAntA = charIDToTypeID( "AntA" );
    var idAnnt = charIDToTypeID( "Annt" );
    var idAnno = charIDToTypeID( "Anno" );
    desc299.putEnumerated( idAntA, idAnnt, idAnno );
executeAction( idpast, desc299, DialogModes.NO );

// =======================================================
var idFltI = charIDToTypeID( "FltI" );
executeAction( idFltI, undefined, DialogModes.NO );

// =======================================================
var idCnvM = charIDToTypeID( "CnvM" );
    var desc300 = new ActionDescriptor();
    var idDpth = charIDToTypeID( "Dpth" );
    desc300.putInteger( idDpth, 16 );
    var idMrge = charIDToTypeID( "Mrge" );
    desc300.putBoolean( idMrge, false );
executeAction( idCnvM, desc300, DialogModes.NO );

// =======================================================
var idsave = charIDToTypeID( "save" );
    var desc301 = new ActionDescriptor();
    var idAs = charIDToTypeID( "As  " );
        var desc302 = new ActionDescriptor();
        var idBytO = charIDToTypeID( "BytO" );
        var idPltf = charIDToTypeID( "Pltf" );
        var idIBMP = charIDToTypeID( "IBMP" );
        desc302.putEnumerated( idBytO, idPltf, idIBMP );
        var idLZWC = charIDToTypeID( "LZWC" );
        desc302.putBoolean( idLZWC, true );
    var idTIFF = charIDToTypeID( "TIFF" );
    desc301.putObject( idAs, idTIFF, desc302 );
    var idIn = charIDToTypeID( "In  " );
    desc301.putPath( idIn, tempFile );
    var idLwCs = charIDToTypeID( "LwCs" );
    desc301.putBoolean( idLwCs, true );
executeAction( idsave, desc301, DialogModes.NO );

// =======================================================
var idCls = charIDToTypeID( "Cls " );
executeAction( idCls, undefined, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc303 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref202 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref202.putProperty( idChnl, idfsel );
    desc303.putReference( idnull, ref202 );
    var idT = charIDToTypeID( "T   " );
        var ref203 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idTrsp = charIDToTypeID( "Trsp" );
        ref203.putEnumerated( idChnl, idChnl, idTrsp );
    desc303.putReference( idT, ref203 );
executeAction( idsetd, desc303, DialogModes.NO );

// =======================================================
var idMk = charIDToTypeID( "Mk  " );
    var desc304 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var idChnl = charIDToTypeID( "Chnl" );
    desc304.putClass( idNw, idChnl );
    var idAt = charIDToTypeID( "At  " );
        var ref204 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idMsk = charIDToTypeID( "Msk " );
        ref204.putEnumerated( idChnl, idChnl, idMsk );
    desc304.putReference( idAt, ref204 );
    var idUsng = charIDToTypeID( "Usng" );
    var idUsrM = charIDToTypeID( "UsrM" );
    var idRvlS = charIDToTypeID( "RvlS" );
    desc304.putEnumerated( idUsng, idUsrM, idRvlS );
executeAction( idMk, desc304, DialogModes.NO );

// =======================================================
var idslct = charIDToTypeID( "slct" );
    var desc305 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref205 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idRGB = charIDToTypeID( "RGB " );
        ref205.putEnumerated( idChnl, idChnl, idRGB );
    desc305.putReference( idnull, ref205 );
    var idMkVs = charIDToTypeID( "MkVs" );
    desc305.putBoolean( idMkVs, false );
executeAction( idslct, desc305, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc306 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref206 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref206.putProperty( idChnl, idfsel );
    desc306.putReference( idnull, ref206 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idAl = charIDToTypeID( "Al  " );
    desc306.putEnumerated( idT, idOrdn, idAl );
executeAction( idsetd, desc306, DialogModes.NO );

// =======================================================
var idFl = charIDToTypeID( "Fl  " );
    var desc307 = new ActionDescriptor();
    var idUsng = charIDToTypeID( "Usng" );
    var idFlCn = charIDToTypeID( "FlCn" );
    var idFrgC = charIDToTypeID( "FrgC" );
    desc307.putEnumerated( idUsng, idFlCn, idFrgC );
    var idOpct = charIDToTypeID( "Opct" );
    var idPrc = charIDToTypeID( "#Prc" );
    desc307.putUnitDouble( idOpct, idPrc, 100.000000 );
    var idMd = charIDToTypeID( "Md  " );
    var idBlnM = charIDToTypeID( "BlnM" );
    var idNrml = charIDToTypeID( "Nrml" );
    desc307.putEnumerated( idMd, idBlnM, idNrml );
executeAction( idFl, desc307, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc308 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref207 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref207.putProperty( idChnl, idfsel );
    desc308.putReference( idnull, ref207 );
    var idT = charIDToTypeID( "T   " );
    var idOrdn = charIDToTypeID( "Ordn" );
    var idNone = charIDToTypeID( "None" );
    desc308.putEnumerated( idT, idOrdn, idNone );
executeAction( idsetd, desc308, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc309 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref208 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref208.putProperty( idChnl, idfsel );
    desc309.putReference( idnull, ref208 );
    var idT = charIDToTypeID( "T   " );
        var ref209 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idMsk = charIDToTypeID( "Msk " );
        ref209.putEnumerated( idChnl, idChnl, idMsk );
    desc309.putReference( idT, ref209 );
executeAction( idsetd, desc309, DialogModes.NO );

// =======================================================
var idsetd = charIDToTypeID( "setd" );
    var desc310 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref210 = new ActionReference();
        var idLyr = charIDToTypeID( "Lyr " );
        var idOrdn = charIDToTypeID( "Ordn" );
        var idTrgt = charIDToTypeID( "Trgt" );
        ref210.putEnumerated( idLyr, idOrdn, idTrgt );
    desc310.putReference( idnull, ref210 );
    var idT = charIDToTypeID( "T   " );
        var desc311 = new ActionDescriptor();
        var idUsrM = charIDToTypeID( "UsrM" );
        desc311.putBoolean( idUsrM, false );
    var idLyr = charIDToTypeID( "Lyr " );
    desc310.putObject( idT, idLyr, desc311 );
executeAction( idsetd, desc310, DialogModes.NO );

// =======================================================
var idnewPlacedLayer = stringIDToTypeID( "newPlacedLayer" );
executeAction( idnewPlacedLayer, undefined, DialogModes.NO );

// =======================================================
var idMk = charIDToTypeID( "Mk  " );
    var desc312 = new ActionDescriptor();
    var idNw = charIDToTypeID( "Nw  " );
    var idChnl = charIDToTypeID( "Chnl" );
    desc312.putClass( idNw, idChnl );
    var idAt = charIDToTypeID( "At  " );
        var ref211 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idMsk = charIDToTypeID( "Msk " );
        ref211.putEnumerated( idChnl, idChnl, idMsk );
    desc312.putReference( idAt, ref211 );
    var idUsng = charIDToTypeID( "Usng" );
    var idUsrM = charIDToTypeID( "UsrM" );
    var idRvlS = charIDToTypeID( "RvlS" );
    desc312.putEnumerated( idUsng, idUsrM, idRvlS );
executeAction( idMk, desc312, DialogModes.NO );

// =======================================================
var idslct = charIDToTypeID( "slct" );
    var desc313 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref212 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idRGB = charIDToTypeID( "RGB " );
        ref212.putEnumerated( idChnl, idChnl, idRGB );
    desc313.putReference( idnull, ref212 );
    var idMkVs = charIDToTypeID( "MkVs" );
    desc313.putBoolean( idMkVs, false );
executeAction( idslct, desc313, DialogModes.NO );
// =======================================================
// =======================================================
// =======================================================
// =======================================================
// =======================================================
} else {
// =======================================================
// =======================================================
// =======================================================
// =======================================================
// =======================================================
if (layerMask) {
    


    // =======================================================
    var idsetd = charIDToTypeID( "setd" );
        var desc657 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
            var ref223 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idfsel = charIDToTypeID( "fsel" );
            ref223.putProperty( idChnl, idfsel );
        desc657.putReference( idnull, ref223 );
        var idT = charIDToTypeID( "T   " );
            var ref224 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idChnl = charIDToTypeID( "Chnl" );
            var idMsk = charIDToTypeID( "Msk " );
            ref224.putEnumerated( idChnl, idChnl, idMsk );
        desc657.putReference( idT, ref224 );
    executeAction( idsetd, desc657, DialogModes.NO );

    // =======================================================
    var idsetd = charIDToTypeID( "setd" );
        var desc658 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
            var ref225 = new ActionReference();
            var idLyr = charIDToTypeID( "Lyr " );
            var idOrdn = charIDToTypeID( "Ordn" );
            var idTrgt = charIDToTypeID( "Trgt" );
            ref225.putEnumerated( idLyr, idOrdn, idTrgt );
        desc658.putReference( idnull, ref225 );
        var idT = charIDToTypeID( "T   " );
            var desc659 = new ActionDescriptor();
            var idUsrM = charIDToTypeID( "UsrM" );
            desc659.putBoolean( idUsrM, false );
        var idLyr = charIDToTypeID( "Lyr " );
        desc658.putObject( idT, idLyr, desc659 );
    executeAction( idsetd, desc658, DialogModes.NO );
    

} else {


    // =======================================================
    var idsetd = charIDToTypeID( "setd" );
        var desc64 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
            var ref32 = new ActionReference();
            var idLyr = charIDToTypeID( "Lyr " );
            var idOrdn = charIDToTypeID( "Ordn" );
            var idTrgt = charIDToTypeID( "Trgt" );
            ref32.putEnumerated( idLyr, idOrdn, idTrgt );
        desc64.putReference( idnull, ref32 );
        var idT = charIDToTypeID( "T   " );
            var desc65 = new ActionDescriptor();
            var idNm = charIDToTypeID( "Nm  " );
            desc65.putString( idNm, "Raw Smart Object" );
        var idLyr = charIDToTypeID( "Lyr " );
        desc64.putObject( idT, idLyr, desc65 );
    executeAction( idsetd, desc64, DialogModes.NO );


}


// =======================================================
var idnewPlacedLayer = stringIDToTypeID( "newPlacedLayer" );
executeAction( idnewPlacedLayer, undefined, DialogModes.NO );


if (layerMask) {


    // =======================================================
    var idMk = charIDToTypeID( "Mk  " );
        var desc660 = new ActionDescriptor();
        var idNw = charIDToTypeID( "Nw  " );
        var idChnl = charIDToTypeID( "Chnl" );
        desc660.putClass( idNw, idChnl );
        var idAt = charIDToTypeID( "At  " );
            var ref226 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idChnl = charIDToTypeID( "Chnl" );
            var idMsk = charIDToTypeID( "Msk " );
            ref226.putEnumerated( idChnl, idChnl, idMsk );
        desc660.putReference( idAt, ref226 );
        var idUsng = charIDToTypeID( "Usng" );
        var idUsrM = charIDToTypeID( "UsrM" );
        var idRvlS = charIDToTypeID( "RvlS" );
        desc660.putEnumerated( idUsng, idUsrM, idRvlS );
    executeAction( idMk, desc660, DialogModes.NO );

    // =======================================================
    var idslct = charIDToTypeID( "slct" );
        var desc661 = new ActionDescriptor();
        var idnull = charIDToTypeID( "null" );
            var ref227 = new ActionReference();
            var idChnl = charIDToTypeID( "Chnl" );
            var idChnl = charIDToTypeID( "Chnl" );
            var idRGB = charIDToTypeID( "RGB " );
            ref227.putEnumerated( idChnl, idChnl, idRGB );
        desc661.putReference( idnull, ref227 );
        var idMkVs = charIDToTypeID( "MkVs" );
        desc661.putBoolean( idMkVs, false );
    executeAction( idslct, desc661, DialogModes.NO );


}


// =======================================================
var idplacedLayerEditContents = stringIDToTypeID( "placedLayerEditContents" );
    var desc67 = new ActionDescriptor();
executeAction( idplacedLayerEditContents, desc67, DialogModes.NO );


// =======================================================
var idCnvM = charIDToTypeID( "CnvM" );
    var desc48 = new ActionDescriptor();
    var idDpth = charIDToTypeID( "Dpth" );
    desc48.putInteger( idDpth, 16 );
    var idMrge = charIDToTypeID( "Mrge" );
    desc48.putBoolean( idMrge, false );
executeAction( idCnvM, desc48, DialogModes.NO );

// =======================================================
var idsave = charIDToTypeID( "save" );
    var desc49 = new ActionDescriptor();
    var idAs = charIDToTypeID( "As  " );
        var desc50 = new ActionDescriptor();
        var idBytO = charIDToTypeID( "BytO" );
        var idPltf = charIDToTypeID( "Pltf" );
        var idIBMP = charIDToTypeID( "IBMP" );
        desc50.putEnumerated( idBytO, idPltf, idIBMP );
        var idLZWC = charIDToTypeID( "LZWC" );
        desc50.putBoolean( idLZWC, true );
    var idTIFF = charIDToTypeID( "TIFF" );
    desc49.putObject( idAs, idTIFF, desc50 );
    var idIn = charIDToTypeID( "In  " );
    desc49.putPath( idIn, tempFile );
    var idCpy = charIDToTypeID( "Cpy " );
    desc49.putBoolean( idCpy, true );
    var idLwCs = charIDToTypeID( "LwCs" );
    desc49.putBoolean( idLwCs, true );
    var idAlpC = charIDToTypeID( "AlpC" );
    desc49.putBoolean( idAlpC, false );
    var idLyrs = charIDToTypeID( "Lyrs" );
    desc49.putBoolean( idLyrs, false );
executeAction( idsave, desc49, DialogModes.NO );

// =======================================================
var idCls = charIDToTypeID( "Cls " );
    var desc19 = new ActionDescriptor();
    var idSvng = charIDToTypeID( "Svng" );
    var idYsN = charIDToTypeID( "YsN " );
    var idN = charIDToTypeID( "N   " );
    desc19.putEnumerated( idSvng, idYsN, idN );
executeAction( idCls, desc19, DialogModes.NO );

} /* one big if for HasLayerTransparency */

// well at least this is the same!
// =======================================================
var idplacedLayerReplaceContents = stringIDToTypeID( "placedLayerReplaceContents" );
    var desc70 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
    desc70.putPath( idnull, tempFile );
executeAction( idplacedLayerReplaceContents, desc70, DialogModes.NO );

tempFile.remove();

} /* try block ender */
catch(e) {
	if (historyDocument != app.activeDocument) {
		app.activeDocument.close( SaveOptions.DONOTSAVECHANGES );
	}
	app.activeDocument = historyDocument;
	app.activeDocument.activeHistoryState = historyState;
	'cancel'; /* make this last so no action gets recorded */
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
///////////////////////////// functions below ////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

// function to see if there is a raster layer mask, returns true or false
function HasLayerMask() {
	var hasLayerMask = false;
	try {
		var ref = new ActionReference();
		var keyUserMaskEnabled = app.charIDToTypeID( 'UsrM' );
		ref.putProperty( app.charIDToTypeID( 'Prpr' ), keyUserMaskEnabled );
		ref.putEnumerated( app.charIDToTypeID( 'Lyr ' ), app.charIDToTypeID( 'Ordn' ), app.charIDToTypeID( 'Trgt' ) );
		var desc = executeActionGet( ref );
		if ( desc.hasKey( keyUserMaskEnabled ) ) {
			hasLayerMask = true;
		}
	}
	catch(e) {
		hasLayerMask = false;
	}
	return hasLayerMask;
}

// see if i can tell that this layer has transparent pixels
function HasLayerTransparency() {
    var hasTransparency = false;
    try {
        SelectLayerTransparency();
        var s = activeDocument.selection;
        if ( null != s && ! s.solid ) {
            activeDocument.selection.deselect();
            return true;
        }
        if ( (s[2].value - s[0].value) == activeDocument.width.value && 
             (s[3].value - s[1].value) == activeDocument.height.value) {
            activeDocument.selection.deselect();
            return false;
        }
        activeDocument.selection.deselect();
    }
    catch(e) {
        activeDocument.selection.deselect();
        hasTransparency = false;
    }
    return hasTransparency;
}

function SelectLayerTransparency() {
    // =======================================================
    var idsetd = charIDToTypeID( "setd" );
    var desc27 = new ActionDescriptor();
    var idnull = charIDToTypeID( "null" );
        var ref21 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idfsel = charIDToTypeID( "fsel" );
        ref21.putProperty( idChnl, idfsel );
    desc27.putReference( idnull, ref21 );
    var idT = charIDToTypeID( "T   " );
        var ref22 = new ActionReference();
        var idChnl = charIDToTypeID( "Chnl" );
        var idChnl = charIDToTypeID( "Chnl" );
        var idTrsp = charIDToTypeID( "Trsp" );
        ref22.putEnumerated( idChnl, idChnl, idTrsp );
    desc27.putReference( idT, ref22 );
    executeAction( idsetd, desc27, DialogModes.NO );
}
